;  DISA-Listing: ram1_QLC3v02_128_dis   filetype  0
        section disa
        data    0
; 
start   equ     *
;       Rom Header
L0000   dc.l    $4AFB0001
        dc.w    L0026-L0000
        dc.w    $0000
        dc.w    $0000
        dc.b    '          QLC  '
L0019   dc.b    'Version 3.02',$0A

L0026   dc.w    $0005
        dc.w    L005A-*
        dc.b    $03,'ROM'
        dc.w    L00C0-*
        dc.b    $03,'LC1'
        dc.w    L00C6-*
        dc.b    $03,'LC2'
        dc.w    L0380-*
        dc.b    $03,'QLC'
        dc.w    L00B0-*
        dc.b    $04,'CRUN',$00
        dc.w    L00B8-*
        dc.b    $06,'CRUN_W',$00
        dc.w    $0000
        dc.w    $0000
        dc.w    $0000
        dc.w    $0000

;       BASIC - Procedure 'ROM'

L005A   lea     L009C(pc),a0
        moveq   #-$01,d1
        moveq   #$00,d3
        moveq   #$01,d0         ; IO_OPEN
        trap    #$02
        suba.l  a1,a1
        movea.l #$0000C000,a2
L006E   adda.l  (a2)+,a1
        cmpa.l  #$0000D254,a2
        bne.s   L006E
        cmpa.l  #$00000000,a1
        bne.s   L008A
        movea.l #$0000C014,a1
        moveq   #$11,d2
        bra.s   L0090
L008A   lea     L00A2(pc),a1
        moveq   #$07,d2
L0090   moveq   #-$01,d3
        moveq   #$07,d0         ; IO_SSTRG
        trap    #$03
        moveq   #$02,d0         ; IO_CLOSE
        trap    #$02
        rts
; 
L009C   dc.w    $0004
        dc.b    'CON_'
L00A2   dc.b    'BAD ROM '
        dc.w    $0000,$0541,$71AF

;       BASIC - Procedure 'CRUN'

L00B0   move.l  #$00000000,d7
        bra.s   L00CA

;       BASIC - Procedure 'CRUN_W'

L00B8   move.l  #-$00010000,d7
        bra.s   L00CA

;       BASIC - Procedure 'LC1'

L00C0   move.b  #$31,d7
        bra.s   L00CA

;       BASIC - Procedure 'LC2'

L00C6   move.b  #$32,d7
L00CA   movea.w $00000116,a2
        moveq   #$01,d4
        jsr     (a2)
        bne.s   L00E8
        subq.w  #$01,d3
        beq.s   L00EA
        moveq   #-$0F,d0        ; ERR_BP
        bra.s   L00E8
L00DE   move.l  d0,-(a7)
        moveq   #$19,d0         ; MT_RECHP
        movea.l a5,a0
        trap    #$01
        move.l  (a7)+,d0
L00E8   rts
; 
L00EA   lea     $00(a1,a6.l),a4
J00EE   moveq   #$18,d0         ; MT_ALCHP
        moveq   #$4C,d1
        add.w   (a4),d1
        moveq   #$00,d2
        trap    #$01
        tst.l   d0
        bne.s   L00E8
        movea.l a0,a5
        move.l  d7,$0020(a5)
        move.w  (a4),d0
        move.l  d0,$0014(a5)
        addq.w  #$01,d0
        tst.w   d7
        beq.s   L0112
        addq.l  #$02,$0014(a5)
L0112   move.b  $00(a4,d0.w),$46(a5,d0.w)
        dbf     d0,L0112
        lea     $0046(a5),a4
        move.l  a4,$0010(a5)
        movea.l a4,a0
        move.w  (a4)+,d0
L0128   cmpi.b  #$20,(a4)+
        dbeq    d0,L0128
        tst.w   d7
        bne.s   L013C
        subq.l  #$03,a4
        suba.l  a0,a4
        move.w  a4,(a0)
        bra.s   L0162
L013C   subq.l  #$01,a4
        movea.l a4,a3
        suba.l  a0,a4
        move.w  a4,(a0)
        moveq   #$00,d0
        move.l  $0014(a5),d0
        add.l   #$00000002,d0
L0150   move.b  $45(a5,d0.w),$47(a5,d0.w)
        cmpa.w  d0,a4
        dbeq    d0,L0150
        move.b  #$50,(a3)+
        move.b  d7,(a3)
L0162   moveq   #$01,d0         ; IO_OPEN
        moveq   #-$01,d1
        moveq   #$00,d3
        trap    #$02
        tst.l   d0
        bne     L00DE
        move.l  a0,$000C(a5)
        moveq   #$47,d0         ; FS_HEADR
        moveq   #$0E,d2
        moveq   #-$01,d3
        movea.l $000C(a5),a0
        lea     $0038(a5),a1
        trap    #$03
        tst.l   d0
        beq.s   L0198
L0188   move.l  d0,-(a7)
        moveq   #$02,d0         ; IO_CLOSE
        movea.l $000C(a5),a0
        trap    #$02
        move.l  (a7)+,d0
        bra     L00DE
; 
L0198   moveq   #$00,d0         ; MT_INF
        trap    #$01
        move.l  a0,$001C(a5)
        move.l  $0038(a5),d2
        jsr     J0376(pc)
        nop                     ;pad
        tst.l   d0
        beq.s   L01BE
        tst.w   d7
        beq.s   L0188
        cmp.l   #$FFFFFFFD,d0
        beq     L0232
        bra.s   L0188
L01BE   move.l  d1,$0008(a5)
        move.l  a0,$0004(a5)
        movea.l a0,a1
        movea.l $000C(a5),a0
        move.l  $0038(a5),d2
        moveq   #$48,d0         ; FS_LOAD
        moveq   #-$01,d3
        trap    #$03
        tst.l   d0
        bne     L02AE
        tst.w   d7
        beq     L0300
        moveq   #$00,d4
        movea.l $0004(a5),a2
        move.w  $0002(a2),d4
        beq.s   L020C
        subq.w  #$01,d4
        move.l  $0004(a5),d5
        add.l   #$00000010,d5
        movea.l $0004(a2),a1
L01FE   movea.l $00(a1,d5.l),a2
        add.l   d5,$00(a2,d5.l)
        addq.l  #$04,a1
        dbf     d4,L01FE
L020C   moveq   #$02,d0         ; IO_CLOSE
        trap    #$02
        movea.l $0004(a5),a2
        move.w  #$600E,(a2)
        movea.l $0004(a2),a0
        adda.l  #$00000010,a0
        adda.l  $0004(a5),a0
        move.l  $0008(a2),d0
        beq     L0300
        bra     L02FA
; 
L0232   moveq   #$03,d0         ; IO_FSTRG
        moveq   #$10,d2
        moveq   #-$01,d3
        movea.l $000C(a5),a0
        lea     $0028(a5),a1
        trap    #$03
        tst.l   d0
        bne     L0188
        moveq   #$00,d0         ; MT_INF
        trap    #$01
        move.l  a0,$001C(a5)
        moveq   #$00,d2
        move.l  $0030(a5),d2
        add.l   $002C(a5),d2
        add.l   #$00000080,d2
        add.l   $0014(a5),d2
        addq.l  #$01,d2
        lsr.l   #$01,d2
        add.l   d2,d2
        jsr     J0376(pc)
        nop                     ;pad
        tst.l   d0
        bmi     L0188
        move.l  d1,$0008(a5)
        move.l  a0,$0004(a5)
        movea.l a0,a1
        movea.l $000C(a5),a0
        move.l  $002C(a5),d5
L0288   move.l  #$00007FFF,d2
        cmp.l   d2,d5
        bgt.s   L0294
        move.l  d5,d2
L0294   moveq   #-$01,d3
        moveq   #$03,d0         ; IO_FSTRG
        trap    #$03
        tst.l   d0
        bne.s   L02AE
        cmp.w   d2,d1
        bne.s   L02AE
        and.l   #$0000FFFF,d2
        sub.l   d2,d5
        bgt.s   L0288
        bra.s   L02C2
L02AE   move.l  d0,-(a7)
        moveq   #$02,d0         ; IO_CLOSE
        trap    #$02
        moveq   #$05,d0         ; MT_FRJOB
        move.l  $0008(a5),d1
        trap    #$01
        move.l  (a7)+,d0
        bra     L00DE
; 
L02C2   moveq   #$00,d4
        move.w  $002A(a5),d4
        beq.s   L02EC
        subq.w  #$01,d4
        move.l  $0004(a5),d5
        moveq   #$04,d2
        moveq   #-$01,d3
L02D4   lea     $0024(a5),a1
        moveq   #$03,d0         ; IO_FSTRG
        trap    #$03
        tst.l   d0
        bmi.s   L02AE
        movea.l $0024(a5),a2
        add.l   d5,$00(a2,d5.l)
        dbf     d4,L02D4
L02EC   movea.l $002C(a5),a0
        adda.l  $0004(a5),a0
        move.l  $0030(a5),d0
        beq.s   L0300
L02FA   clr.b   (a0)+
        subq.l  #$01,d0
        bne.s   L02FA
L0300   movea.l $000C(a5),a0
        moveq   #$02,d0         ; IO_CLOSE
        trap    #$02
        move.l  $0004(a5),d1
        movea.l $001C(a5),a1
        movea.l $0068(a1),a1
        move.l  $0008(a5),d0
        asl.l   #$02,d0
        movea.l $00(a1,d0.w),a1
        move.l  d1,$0004(a1)
        move.l  $005C(a1),d0
        lsr.l   #$01,d0
        add.l   d0,d0
        movea.l d0,a4
        move.l  $0014(a5),d0
        addq.l  #$01,d0
        lsr.l   #$01,d0
        add.l   d0,d0
        movea.l $0010(a5),a2
        adda.l  #$00000002,a2
        adda.l  d0,a2
        lsr.l   #$01,d0
        subq.l  #$01,d0
L0346   move.w  -(a2),-(a4)
        dbf     d0,L0346
        move.w  $0016(a5),-(a4)
        move.w  #$0000,-(a4)
        move.l  a4,$005C(a1)
        move.l  $0008(a5),d4
        moveq   #$19,d0         ; MT_RECHP
        movea.l a5,a0
        trap    #$01
        moveq   #$0A,d0         ; MT_ACTIV
        move.l  d4,d1
        moveq   #$20,d2
        move.w  $0020(a5),d3
        tst.w   d7
        beq.s   L0372
        moveq   #-$01,d3
L0372   trap    #$01
        rts
; 
J0376   moveq   #$01,d0         ; MT_CJOB
        moveq   #$00,d3
        suba.l  a1,a1
        trap    #$01
        rts
; 
;       BASIC - Procedure 'QLC'
L0380   moveq   #$18,d0         ; MT_ALCHP
        move.l  #$000000A2,d1
        moveq   #-$01,d2
        trap    #$01
        movea.l a0,a5
        moveq   #$01,d0         ; IO_OPEN
        moveq   #-$01,d1
        moveq   #$00,d3
        lea     L05B0(pc),a0
        trap    #$02
        jsr     J0560(pc)
        nop                     ;pad
        moveq   #$0B,d0         ; SD_CHENQ
        moveq   #-$01,d3
        lea     $0000(a5),a1
        trap    #$03
        moveq   #$2D,d0         ; SD_SETSZ
        moveq   #$03,d1
        moveq   #$01,d2
        moveq   #-$01,d3
        trap    #$03
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$18,d2
        moveq   #-$01,d3
        lea     L05C6(pc),a1
        trap    #$03
        moveq   #$2D,d0         ; SD_SETSZ
        moveq   #$00,d1
        moveq   #$00,d2
        moveq   #-$01,d3
        trap    #$03
        cmpi.w  #$0032,(a5)
        blt.s   L03D8
        moveq   #$14,d2
        jsr     J058C(pc)
        nop                     ;pad
L03D8   moveq   #$07,d0         ; IO_SSTRG
        moveq   #$23,d2
        moveq   #-$01,d3
        lea     L05DE(pc),a1
        trap    #$03
        cmpi.w  #$0032,(a5)
        blt.s   L03F2
        moveq   #$14,d2
        jsr     J058C(pc)
        nop                     ;pad
L03F2   moveq   #$07,d0         ; IO_SSTRG
        moveq   #$26,d2
        moveq   #-$01,d3
        lea     L0601(pc),a1
        trap    #$03
        cmpi.w  #$0032,(a5)
        blt.s   L040E
        moveq   #$23,d2
        jsr     J058C(pc)
        nop                     ;pad
        bra.s   L0416
L040E   moveq   #$0F,d2
        jsr     J058C(pc)
        nop                     ;pad
L0416   moveq   #$07,d0         ; IO_SSTRG
        moveq   #$0D,d2
        moveq   #-$01,d3
        lea     L0019(pc),a1
        trap    #$03
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$3A,d2
        moveq   #-$01,d3
        lea     L0627(pc),a1
        trap    #$03
        moveq   #$02,d0         ; IO_FLINE
        moveq   #$0D,d2
        moveq   #-$01,d3
        lea     $0002(a5),a1
        trap    #$03
        move.b  #$20,-$0001(a1)
        move.l  a1,d7
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$1C,d2
        moveq   #-$01,d3
        lea     L0661(pc),a1
        trap    #$03
        moveq   #$02,d0         ; IO_FLINE
        moveq   #$21,d2
        moveq   #-$01,d3
        lea     $0081(a5),a1
        trap    #$03
        cmpi.b  #$43,-$0002(a1)
        beq.s   L046A
        cmpi.b  #$63,-$0002(a1)
        bne.s   L0478
L046A   cmpi.b  #$5F,-$0003(a1)
        bne.s   L0478
        suba.l  #$00000002,a1
L0478   move.b  #$20,-$0001(a1)
        move.l  d7,d6
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$12,d2
        moveq   #-$01,d3
        lea     L067D(pc),a1
        trap    #$03
        moveq   #$02,d0         ; IO_FLINE
        moveq   #$51,d2
        moveq   #-$01,d3
        movea.l d7,a1
        trap    #$03
        jsr     J0598(pc)
        nop                     ;pad
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$43,d2
        moveq   #-$01,d3
        lea     L068F(pc),a1
        trap    #$03
        jsr     J0584(pc)
        nop                     ;pad
        jsr     J057C(pc)
        nop                     ;pad
        sub.l   a5,d7
        sub.l   #$00000002,d7
        move.w  d7,(a5)
        movea.l a5,a4
        move.b  #$31,d7
        move.l  a5,-(a7)
        move.l  a0,-(a7)
        move.l  d6,-(a7)
        jsr     J00EE(pc)
        nop                     ;pad
        move.l  (a7)+,d6
        movea.l (a7)+,a0
        movea.l (a7)+,a5
        tst.l   d0
        bmi.s   L054A
        jsr     J0560(pc)
        nop                     ;pad
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$47,d2
        moveq   #-$01,d3
        lea     L06D2(pc),a1
        trap    #$03
        jsr     J0584(pc)
        nop                     ;pad
        cmp.b   #$0A,d1
        bne.s   L054A
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$12,d2
        moveq   #-$01,d3
        lea     L0719(pc),a1
        trap    #$03
        moveq   #$02,d0         ; IO_FLINE
        moveq   #$51,d2
        moveq   #-$01,d3
        movea.l d6,a1
        trap    #$03
        jsr     J0598(pc)
        nop                     ;pad
        moveq   #$07,d0         ; IO_SSTRG
        moveq   #$43,d2
        moveq   #-$01,d3
        lea     L072A(pc),a1
        trap    #$03
        jsr     J0584(pc)
        nop                     ;pad
        jsr     J057C(pc)
        nop                     ;pad
        sub.l   a5,d7
        sub.l   #$00000002,d7
        move.w  d7,(a5)
        movea.l a5,a4
        move.b  #$32,d7
        move.l  a5,-(a7)
        move.l  a0,-(a7)
        jsr     J00EE(pc)
        nop                     ;pad
        movea.l (a7)+,a0
        movea.l (a7)+,a5
L054A   move.l  d0,-(a7)
        jsr     J0560(pc)
        nop                     ;pad
        moveq   #$02,d0         ; IO_CLOSE
        trap    #$02
        moveq   #$19,d0         ; SD_SCRTP
        movea.l a5,a0
        trap    #$03
        move.l  (a7)+,d0
        rts
; 
J0560   moveq   #$0C,d0         ; SD_BORDR
        moveq   #$00,d2
        moveq   #-$01,d3
        moveq   #$00,d1
        trap    #$03
        jsr     J057C(pc)
        nop                     ;pad
        moveq   #$0C,d0         ; SD_BORDR
        moveq   #$03,d2
        moveq   #-$01,d3
        moveq   #$03,d1
        trap    #$03
        rts
; 
J057C   moveq   #$20,d0         ; SD_CLEAR
        moveq   #-$01,d3
        trap    #$03
        rts
; 
J0584   moveq   #$01,d0         ; IO_FBYTE
        moveq   #-$01,d3
        trap    #$03
        rts
; 
J058C   moveq   #$07,d0         ; IO_SSTRG
        moveq   #-$01,d3
        lea     L076D(pc),a1
        trap    #$03
        rts
; 
J0598   move.b  #$20,-$0001(a1)
        lea     $0081(a5),a2
L05A2   cmpi.b  #$20,(a2)
        beq.s   L05AC
        move.b  (a2)+,(a1)+
        bra.s   L05A2
L05AC   move.l  a1,d7
        rts
; 
L05B0   dc.w    $0013
        dc.b    'CON_512x206a0x0_128 '
L05C6   dc.b    '         MetaComCo QLC',$0A,$0A
L05DE   dc.b    '        Copyright  1985 MetaComCo',$0A
L0601   dc.b    '     26 Portland Square, Bristol, UK',$0A
L0626   dc.b    $0A
L0627   dc.b    $0A,'    Which device do you wish to '
        dc.b    'load the compiler from?  '
L0661   dc.b    '    Name of C source file?  '
L067D   dc.b    '    LC1 options?  '
L068F   dc.b    '    Put PHASE 1 in your chosen device',$0A
        dc.b    '    Press any key when ready',$0A
L06D2   dc.b    '    Press return if LC1 was successful',$0A
        dc.b    '    Press any other key to quit',$0A
L0719   dc.b    '    LC2 options? '
L072A   dc.b    '    Put PHASE 2 in your chosen device',$0A
        dc.b    '    Press any key when ready',$0A
L076D   dc.b    '                                   '
        dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000

M0800   jmp     J0B92(pc)
        nop                     ;pad
; 
        jmp     J0BB4(pc)
        nop                     ;pad
; 
        jmp     J0BD6(pc)
        nop                     ;pad
; 
        jmp     J0C1C(pc)
        nop                     ;pad
; 
        jmp     J0C5A(pc)
        nop                     ;pad
; 
        jmp     J0C7E(pc)
        nop                     ;pad
; 
        jmp     J0CC4(pc)
        nop                     ;pad
; 
        jmp     J0D0A(pc)
        nop                     ;pad
; 
        jmp     J0D2E(pc)
        nop                     ;pad
; 
        jmp     J0D58(pc)
        nop                     ;pad
; 
        jmp     J0DAC(pc)
        nop                     ;pad
; 
        jmp     J0DD8(pc)
        nop                     ;pad
; 
        jmp     J10C6(pc)
        nop                     ;pad
; 
        jmp     J11C8(pc)
        nop                     ;pad
; 
        jmp     J120A(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J090E(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J096E(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J09E6(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J0A0E(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J0A66(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J0AA4(pc)
        nop                     ;pad
; 
        adda.l  #$000075B4,a5
        jmp     J0AE2(pc)
        nop                     ;pad
; 
        adda.l  #$000075B0,a5
        jmp     J0B84(pc)
        nop                     ;pad
; 
        jmp     J0DE4(pc)
        nop                     ;pad
; 
        jmp     J0E06(pc)
        nop                     ;pad
; 
        jmp     J10F2(pc)
        nop                     ;pad
; 
        jmp     J1128(pc)
        nop                     ;pad
; 
        jmp     J1006(pc)
        nop                     ;pad
; 
        jmp     J100E(pc)
        nop                     ;pad
; 
        jmp     J0F7A(pc)
        nop                     ;pad
; 
        jmp     J0EDC(pc)
        nop                     ;pad
; 
        jmp     J0EC2(pc)
        nop                     ;pad
; 
        jmp     J0E8C(pc)
        nop                     ;pad
; 
        jmp     J0DC4(pc)
        nop                     ;pad
; 
        jmp     J0D96(pc)
        nop                     ;pad
; 
        jmp     J0C0A(pc)
        nop                     ;pad
; 
        jmp     J0BF8(pc)
        nop                     ;pad
; 
J090E   link    a6,#-$006A
        clr.l   -$006A(a6)
L0916   movea.l $0008(a6),a0
        move.b  (a0),d0
        move.l  -$006A(a6),d1
        move.b  d0,-$64(a6,d1.l)
        addq.l  #$01,$0008(a6)
        tst.b   d0
        beq.s   L0932
        addq.l  #$01,-$006A(a6)
        bra.s   L0916
L0932   move.l  -$006A(a6),d0
        move.w  d0,-$0066(a6)
        moveq   #$01,d0
        move.l  d0,-$0020(a6)
        moveq   #-$01,d0        ; ERR_NC
        move.l  d0,-$001C(a6)
        clr.l   -$0014(a6)
        lea     -$0066(a6),a0
        move.l  a0,-$0010(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BB4(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        move.l  -$0030(a6),d0
        unlk    a6
        rts
; 
J096E   link    a6,#-$006A
        clr.l   -$006A(a6)
L0976   movea.l $0008(a6),a0
        move.b  (a0),d0
        move.l  -$006A(a6),d1
        move.b  d0,-$64(a6,d1.l)
        addq.l  #$01,$0008(a6)
        tst.b   d0
        beq.s   L0992
        addq.l  #$01,-$006A(a6)
        bra.s   L0976
L0992   move.l  -$006A(a6),d0
        move.w  d0,-$0066(a6)
        moveq   #$04,d0
        move.l  d0,-$0020(a6)
        moveq   #-$01,d0        ; ERR_NC
        move.l  d0,-$001C(a6)
        lea     -$0066(a6),a0
        move.l  a0,-$0010(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BB4(pc)
        nop                     ;pad
        addq.l  #$08,a7
        moveq   #$01,d0
        move.l  d0,-$0020(a6)
        moveq   #$02,d0
        move.l  d0,-$0014(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BB4(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        move.l  -$0030(a6),d0
        unlk    a6
        rts
; 
J09E6   link    a6,#-$0040
        moveq   #$02,d0
        move.l  d0,-$0020(a6)
        move.l  $0008(a6),-$0010(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BB4(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        unlk    a6
        rts
; 
J0A0E   link    a6,#-$006A
        clr.l   -$006A(a6)
L0A16   movea.l $0008(a6),a0
        move.b  (a0),d0
        move.l  -$006A(a6),d1
        move.b  d0,-$24(a6,d1.l)
        addq.l  #$01,$0008(a6)
        tst.b   d0
        beq.s   L0A32
        addq.l  #$01,-$006A(a6)
        bra.s   L0A16
L0A32   move.l  -$006A(a6),d0
        move.w  d0,-$0026(a6)
        moveq   #$04,d0
        move.l  d0,-$0046(a6)
        moveq   #-$01,d0        ; ERR_NC
        move.l  d0,-$0042(a6)
        lea     -$0026(a6),a0
        move.l  a0,-$0036(a6)
        pea     -$0066(a6)
        pea     -$0046(a6)
        jsr     J0BB4(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        unlk    a6
        rts
; 
J0A66   link    a6,#-$0040
        moveq   #$03,d0
        move.l  d0,-$0020(a6)
        move.l  $0010(a6),-$0018(a6)
        moveq   #-$01,d0        ; ERR_NC
        move.l  d0,-$0014(a6)
        move.l  $0008(a6),-$0010(a6)
        move.l  $000C(a6),-$000C(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BD6(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        move.l  -$003C(a6),d0
        unlk    a6
        rts
; 
J0AA4   link    a6,#-$0040
        moveq   #$07,d0
        move.l  d0,-$0020(a6)
        move.l  $0010(a6),-$0018(a6)
        moveq   #-$01,d0        ; ERR_NC
        move.l  d0,-$0014(a6)
        move.l  $0008(a6),-$0010(a6)
        move.l  $000C(a6),-$000C(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BD6(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        move.l  -$003C(a6),d0
        unlk    a6
        rts
; 
J0AE2   link    a6,#-$0040
        moveq   #-$01,d0        ; ERR_NC
        move.l  d0,-$0014(a6)
        move.l  $0008(a6),-$0010(a6)
        tst.l   $0010(a6)
        beq.s   L0B46
        move.l  $0010(a6),d0
        cmpi.l  #$00000001,d0
        beq.s   L0B1C
        cmpi.l  #$00000002,d0
        bne.s   L0B28
        move.l  #$007FFFFF,-$001C(a6)
        moveq   #$42,d0
        move.l  d0,-$0020(a6)
        bra.s   L0B2E
L0B1C   clr.l   -$001C(a6)
        moveq   #$43,d0
        move.l  d0,-$0020(a6)
        bra.s   L0B2E
L0B28   moveq   #-$01,d0        ; ERR_NC
        unlk    a6
        rts
; 
L0B2E   pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BD6(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  -$003C(a6),d0
        add.l   d0,$000C(a6)
L0B46   move.l  $000C(a6),-$001C(a6)
        moveq   #$42,d0
        move.l  d0,-$0020(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BD6(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  d0,-$75B4(a5)
        cmpi.l  #$FFFFFFF6,d0   ; ERR_EF
        bne.s   L0B7C
        move.l  -$003C(a6),d0
        cmp.l   $000C(a6),d0
        bne.s   L0B7C
        clr.l   -$75B4(a5)
L0B7C   move.l  -$003C(a6),d0
        unlk    a6
        rts
; 
J0B84   link    a6,#$0000
        move.l  $0008(a6),-$75B0(a5)
        unlk    a6
        rts
; 
J0B92   link    a6,#$0000
        movem.l a2-a3/a5,-(a7)
        movea.l $0008(a6),a5
        movem.l (a5),d0-d3/a0-a3
        trap    #$01
        movea.l $000C(a6),a5
        movem.l d0-d3/a0-a3,(a5)
        movem.l (a7)+,a2-a3/a5
        unlk    a6
        rts
; 
J0BB4   link    a6,#$0000
        movem.l a2-a3/a5,-(a7)
        movea.l $0008(a6),a5
        movem.l (a5),d0-d3/a0-a3
        trap    #$02
        movea.l $000C(a6),a5
        movem.l d0-d3/a0-a3,(a5)
        movem.l (a7)+,a2-a3/a5
        unlk    a6
        rts
; 
J0BD6   link    a6,#$0000
        movem.l a2-a3/a5,-(a7)
        movea.l $0008(a6),a5
        movem.l (a5),d0-d3/a0-a3
        trap    #$03
        movea.l $000C(a6),a5
        movem.l d0-d3/a0-a3,(a5)
        movem.l (a7)+,a2-a3/a5
        unlk    a6
        rts
; 
J0BF8   move.l  d1,-(a7)
        jsr     J0EC2(pc)
        nop                     ;pad
        jsr     J0DC4(pc)
        nop                     ;pad
        move.l  (a7)+,d1
        rts
; 
J0C0A   move.l  d1,-(a7)
        jsr     J0D96(pc)
        nop                     ;pad
        jsr     J0E8C(pc)
        nop                     ;pad
        move.l  (a7)+,d1
        rts
; 
J0C1C   link    a6,#-$0044
        moveq   #$18,d0
        move.l  d0,-$0020(a6)
        move.l  $000C(a6),-$001C(a6)
        move.l  $0008(a6),-$0018(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0B92(pc)
        nop                     ;pad
        addq.l  #$08,a7
        movea.l $0010(a6),a0
        move.l  -$003C(a6),(a0)
        movea.l $0014(a6),a0
        move.l  -$0030(a6),(a0)
        move.l  d0,-$0044(a6)
        unlk    a6
        rts
; 
J0C5A   link    a6,#-$0040
        moveq   #$19,d0
        move.l  d0,-$0020(a6)
        move.l  $0008(a6),-$0010(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0B92(pc)
        nop                     ;pad
        addq.l  #$08,a7
        unlk    a6
        rts
; 
J0C7E   link    a6,#-$0044
        moveq   #$02,d0
        move.l  d0,-$0020(a6)
        move.l  $0014(a6),-$0018(a6)
        move.l  $000C(a6),-$0014(a6)
        move.l  $0008(a6),-$0010(a6)
        move.l  $0010(a6),-$000C(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BD6(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  -$003C(a6),d1
        ext.l   d1
        movea.l $0018(a6),a0
        move.l  d1,(a0)
        move.l  d0,-$0044(a6)
        unlk    a6
        rts
; 
J0CC4   link    a6,#-$0044
        moveq   #$03,d0
        move.l  d0,-$0020(a6)
        move.l  $0014(a6),-$0018(a6)
        move.l  $000C(a6),-$0014(a6)
        move.l  $0008(a6),-$0010(a6)
        move.l  $0010(a6),-$000C(a6)
        pea     -$0040(a6)
        pea     -$0020(a6)
        jsr     J0BD6(pc)
        nop                     ;pad
        addq.l  #$08,a7
        move.l  -$003C(a6),d1
        ext.l   d1
        movea.l $0018(a6),a0
        move.l  d1,(a0)
        move.l  d0,-$0044(a6)
        unlk    a6
        rts
; 
J0D0A   link    a6,#-$0004
        clr.l   -$0004(a6)
L0D12   movea.l $0008(a6),a0
        adda.l  -$0004(a6),a0
        move.b  (a0),d0
        tst.b   d0
        beq.s   L0D26
        addq.l  #$01,-$0004(a6)
        bra.s   L0D12
L0D26   move.l  -$0004(a6),d0
        unlk    a6
        rts
; 
J0D2E   link    a6,#-$0004
        move.l  $0008(a6),-$0004(a6)
L0D38   movea.l -$0004(a6),a0
        addq.l  #$01,-$0004(a6)
        movea.l $000C(a6),a1
        move.b  (a1),d0
        move.b  d0,(a0)
        addq.l  #$01,$000C(a6)
        tst.b   (a0)
        bne.s   L0D38
        move.l  $0008(a6),d0
        unlk    a6
        rts
; 
J0D58   link    a6,#-$0004
        move.l  $0008(a6),-$0004(a6)
L0D62   tst.l   $0010(a6)
        ble.s   L0D88
        movea.l $000C(a6),a0
        move.b  (a0),d0
        movea.l -$0004(a6),a0
        move.b  d0,(a0)
        addq.l  #$01,$000C(a6)
        tst.b   (a0)
        beq.s   L0D88
        addq.l  #$01,-$0004(a6)
        nop
        subq.l  #$01,$0010(a6)
        bra.s   L0D62
L0D88   movea.l -$0004(a6),a0
        clr.b   (a0)
        move.l  $0008(a6),d0
        unlk    a6
        rts
; 
J0D96   move.l  d2,-(a7)
        jsr     J0DE4(pc)
        nop                     ;pad
        move.l  d1,d2
        moveq   #$00,d1
        jsr     J1128(pc)
        nop                     ;pad
        move.l  (a7)+,d2
        rts
; 
J0DAC   movea.l $0004(a7),a0
        move.l  $0008(a7),d0
        subq.l  #$01,d0
        bmi.s   L0DC2
        move.l  $000C(a7),d1
L0DBC   move.b  d1,(a0)+
        subq.l  #$01,d0
        bpl.s   L0DBC
L0DC2   rts
; 
J0DC4   move.l  d2,-(a7)
        jsr     J10F2(pc)
        nop                     ;pad
        move.l  d2,d1
        jsr     J0E06(pc)
        nop                     ;pad
        move.l  (a7)+,d2
        rts
; 
J0DD8   move.l  d0,-(a7)
        or.l    d1,(a7)+
        beq.s   L0DE2
        bchg    #$1F,d0
L0DE2   rts
; 
J0DE4   move.l  d0,d1
        and.l   #$7FFFFFFF,d0
        beq.s   L0E04
        swap    d1
        ext.l   d1
        and.l   #$80007FFF,d1
        lsr.w   #$07,d1
        sub.w   #$007F,d1
        lsl.l   #$08,d0
        bset    #$1F,d0
L0E04   rts
; 
J0E06   move.l  d2,-(a7)
        tst.l   d0
        beq.s   L0E58
        subq.w  #$08,d1
L0E0E   move.l  d0,-(a7)
        andi.l  #$FF000000,(a7)+
        beq.s   L0E34
L0E18   addq.w  #$01,d1
        lsr.l   #$01,d0
        roxr.l  #$01,d2
        move.l  d0,-(a7)
        andi.l  #$FF000000,(a7)+
        bne.s   L0E18
        tst.l   d2
        bpl.s   L0E34
        addq.l  #$01,d0
        bra.s   L0E0E
L0E30   subq.w  #$01,d1
        lsl.l   #$01,d0
L0E34   btst    #$17,d0
        beq.s   L0E30
        add.w   #$007F,d1
        ble.s   L0E5C
        cmp.w   #$00FF,d1
        bge.s   L0E6C
        bclr    #$17,d0
        lsl.w   #$07,d1
        move.w  d1,-(a7)
        swap    d1
        or.w    (a7)+,d1
        swap    d1
        clr.w   d1
        or.l    d1,d0
L0E58   move.l  (a7)+,d2
        rts
; 
L0E5C   move.l  #$00000001,-(a7)
        jsr     J0B84(pc)
        nop                     ;pad
        clr.l   d0
        bra.s   L0E86
L0E6C   move.l  #$00000002,-(a7)
        jsr     J0B84(pc)
        nop                     ;pad
        move.l  #$7F800000,d0
        tst.l   d1
        bpl.s   L0E86
        bset    #$1F,d0
L0E86   lea     $0004(a7),a7
        bra.s   L0E58
J0E8C   move.l  d2,-(a7)
        move.l  d0,d2
        bclr    #$1F,d2
        tst.l   d2
        bne.s   L0E9C
L0E98   moveq   #$00,d0
        bra.s   L0EBE
L0E9C   jsr     J10F2(pc)
        nop                     ;pad
        addq.w  #$01,d2
        ble.s   L0E98
        subi.w  #$0020,d2
        bmi.s   L0EB4
        moveq   #-$01,d0        ; ERR_NC
        bclr    #$1F,d0
        bra.s   L0EB8
L0EB4   neg.w   d2
        lsr.l   d2,d0
L0EB8   tst.l   d2
        bpl.s   L0EBE
        neg.l   d0
L0EBE   move.l  (a7)+,d2
        rts
; 
J0EC2   move.l  d2,-(a7)
        clr.l   d1
        moveq   #$1F,d2
        tst.l   d0
        bpl.s   L0ED2
        neg.l   d0
        bset    #$1F,d2
L0ED2   jsr     J1128(pc)
        nop                     ;pad
        move.l  (a7)+,d2
        rts
; 
J0EDC   movem.l d2-d7,-(a7)
        move.l  d2,-(a7)
        andi.w  #$7FFF,(a7)
        or.l    d3,(a7)+
        bne.s   L0F00
        move.l  #$00000003,-(a7)
        jsr     J0B84(pc)
        nop                     ;pad
        lea     $0004(a7),a7
        clr.l   d0
        clr.l   d1
        bra.s   L0F44
L0F00   move.l  d0,-(a7)
        andi.w  #$7FFF,(a7)
        or.l    d1,(a7)+
        beq.s   L0F44
        move.l  d2,-(a7)
        jsr     J10F2(pc)
        nop                     ;pad
        move.l  d0,d4
        move.l  d1,d5
        move.l  d2,d6
        move.l  (a7)+,d0
        move.l  d3,d1
        jsr     J10F2(pc)
        nop                     ;pad
        exg     d2,d6
        sub.w   d6,d2
        swap    d6
        swap    d2
        eor.w   d6,d2
        swap    d2
        move.l  d0,d6
        move.l  d1,d7
        clr.l   d0
        clr.l   d1
        clr.l   d3
        bsr.s   L0F4A
        move.l  d1,d0
        bsr.s   L0F4A
        jsr     J1128(pc)
        nop                     ;pad
L0F44   movem.l (a7)+,d2-d7
        rts
; 
L0F4A   move.w  #$0020,-(a7)
        moveq   #$00,d1
L0F50   lsl.l   #$01,d1
        tst.l   d3
        bne.s   L0F60
        cmp.l   d6,d4
        bcs.s   L0F6A
        bne.s   L0F60
        cmp.l   d7,d5
        bcs.s   L0F6A
L0F60   sub.l   d7,d5
        subx.l  d6,d4
        bcc.s   L0F68
        subq.l  #$01,d3
L0F68   addq.l  #$01,d1
L0F6A   lsl.l   #$01,d5
        roxl.l  #$01,d4
        roxl.l  #$01,d3
        subq.w  #$01,(a7)
        bne.s   L0F50
        lea     $0002(a7),a7
        rts
; 
J0F7A   movem.l d2-d7,-(a7)
        move.l  d0,-(a7)
        andi.w  #$7FFF,(a7)
        eor.l   d1,(a7)+
        beq.s   L0FDE
        move.l  d2,-(a7)
        andi.w  #$7FFF,(a7)
        eor.l   d3,(a7)+
        bne.s   L0F98
        clr.l   d0
        clr.l   d1
        bra.s   L0FDE
L0F98   move.l  d2,-(a7)
        jsr     J10F2(pc)
        nop                     ;pad
        move.l  d0,d4
        move.l  d1,d5
        move.l  d2,d6
        move.l  (a7)+,d0
        move.l  d3,d1
        jsr     J10F2(pc)
        nop                     ;pad
        add.w   d6,d2
        swap    d6
        swap    d2
        eor.w   d6,d2
        swap    d2
        move.l  d0,d6
        move.l  d1,d7
        clr.l   d0
        clr.l   d1
        clr.l   d3
        bsr.s   L0FE4
        move.l  d6,d7
        bsr.s   L0FE4
        tst.l   d3
        beq.s   L0FD8
        roxr.l  #$01,d3
        roxr.l  #$01,d0
        roxr.l  #$01,d1
        add.w   #$0001,d2
L0FD8   jsr     J1128(pc)
        nop                     ;pad
L0FDE   movem.l (a7)+,d2-d7
        rts
; 
L0FE4   move.w  #$0020,-(a7)
L0FE8   roxr.l  #$01,d3
        roxr.l  #$01,d0
        roxr.l  #$01,d1
        ror.l   #$01,d7
        bcc.s   L0FF6
        add.l   d5,d1
        addx.l  d4,d0
L0FF6   move.w  sr,d3
        subi.w  #$0001,(a7)
        bne.s   L0FE8
        adda.l  #$00000002,a7
        rts
; 
J1006   movem.l d2-d7,-(a7)
        clr.l   d7
        bra.s   L1018
J100E   movem.l d2-d7,-(a7)
        move.l  #$80000000,d7
L1018   move.l  d2,d4
        bclr    #$1F,d4
        move.l  d4,-(a7)
        or.l    d3,(a7)+
        beq     L10C0
        move.l  d0,d4
        bclr    #$1F,d4
        move.l  d4,-(a7)
        or.l    d1,(a7)+
        bne.s   L103C
        move.l  d2,d0
        move.l  d3,d1
        eor.l   d7,d0
        bra     L10C0
; 
L103C   move.l  d2,-(a7)
        jsr     J10F2(pc)
        nop                     ;pad
        move.l  d0,d4
        move.l  d1,d5
        move.l  d2,d6
        move.l  (a7)+,d0
        move.l  d3,d1
        jsr     J10F2(pc)
        nop                     ;pad
        move.l  d6,d3
        move.w  d2,d3
        sub.w   d6,d3
        bge.s   L107A
        neg.w   d3
        cmpi.w  #$0040,d3
        blt.s   L106C
        move.l  d4,d0
        move.l  d5,d1
        move.l  d6,d2
        bra.s   L10BA
L106C   subq.w  #$01,d3
L106E   lsr.l   #$01,d0
        roxr.l  #$01,d1
        dbf     d3,L106E
        move.w  d6,d3
        bra.s   L1092
L107A   beq.s   L1090
        cmpi.w  #$0040,d3
        blt.s   L1086
        eor.l   d7,d2
        bra.s   L10BA
L1086   subq.w  #$01,d3
L1088   lsr.l   #$01,d4
        roxr.l  #$01,d5
        dbf     d3,L1088
L1090   move.w  d2,d3
L1092   eor.l   d2,d6
        eor.l   d7,d6
        bmi.s   L10A6
        add.l   d5,d1
        addx.l  d4,d0
        bcc.s   L10B8
        roxr.l  #$01,d0
        roxr.l  #$01,d1
        addq.w  #$01,d3
        bra.s   L10B8
L10A6   sub.l   d1,d5
        subx.l  d0,d4
        bcc.s   L10B4
        bchg    #$1F,d3
        neg.l   d5
        negx.l  d4
L10B4   move.l  d4,d0
        move.l  d5,d1
L10B8   move.l  d3,d2
L10BA   jsr     J1128(pc)
        nop                     ;pad
L10C0   movem.l (a7)+,d2-d7
        rts
; 
J10C6   movem.l d0-d3,-(a7)
        move.l  d0,-(a7)
        bclr    #$1F,d0
        tst.l   (a7)+
        bpl.s   L10D8
        neg.l   d1
        negx.l  d0
L10D8   move.l  d2,-(a7)
        bclr    #$1F,d2
        tst.l   (a7)+
        bpl.s   L10E6
        neg.l   d3
        negx.l  d2
L10E6   cmp.l   d2,d0
        bne.s   L10EC
        cmp.l   d3,d1
L10EC   movem.l (a7)+,d0-d3
        rts
; 
J10F2   move.l  d0,d2
        and.l   #$7FFFFFFF,d0
        bne.s   L1104
        moveq   #$00,d0
        moveq   #$00,d1
        moveq   #$00,d2
        bra.s   L1126
L1104   swap    d2
        ext.l   d2
        asr.w   #$04,d2
        and.l   #$800007FF,d2
        sub.w   #$03FF,d2
        move.l  d2,-(a7)
        moveq   #$0A,d2
L1118   lsl.l   #$01,d1
        roxl.l  #$01,d0
        dbf     d2,L1118
        bset    #$1F,d0
        move.l  (a7)+,d2
L1126   rts
; 
J1128   move.l  d3,-(a7)
        move.l  d0,-(a7)
        or.l    d1,(a7)+
        beq.s   L1194
        sub.w   #$000B,d2
        tst.l   d0
        bne.s   L1140
        move.l  d1,d0
        clr.l   d1
        sub.w   #$0020,d2
L1140   move.l  d0,-(a7)
        andi.l  #$FFE00000,(a7)+
        beq.s   L116E
L114A   addq.w  #$01,d2
        lsr.l   #$01,d0
        roxr.l  #$01,d1
        roxr.l  #$01,d3
        move.l  d0,-(a7)
        andi.l  #$FFE00000,(a7)+
        bne.s   L114A
        tst.l   d3
        bpl.s   L116E
        addq.l  #$01,d1
        bcc.s   L116E
        addq.l  #$01,d0
        bra.s   L1140
L1168   subq.w  #$01,d2
        lsl.l   #$01,d1
        roxl.l  #$01,d0
L116E   btst    #$14,d0
        beq.s   L1168
        add.w   #$03FF,d2
        ble.s   L1198
        cmp.w   #$07FF,d2
        bge.s   L11A8
        and.l   #$000FFFFF,d0
        lsl.w   #$04,d2
        move.w  d2,-(a7)
        clr.w   d2
        swap    d2
        or.w    (a7)+,d2
        swap    d2
        or.l    d2,d0
L1194   move.l  (a7)+,d3
        rts
; 
L1198   move.l  #$00000001,-(a7)
        jsr     J0B84(pc)
        nop                     ;pad
        moveq   #$00,d0
        bra.s   L11C0
L11A8   move.l  #$00000002,-(a7)
        jsr     J0B84(pc)
        nop                     ;pad
        move.w  #$7FF0,d0
        swap    d2
        or.w    d2,d0
        swap    d0
        clr.w   d0
L11C0   lea     $0004(a7),a7
        moveq   #$00,d1
        bra.s   L1194
J11C8   movem.l d2-d5,-(a7)
        move.l  d1,d5
        beq.s   L1202
        bpl.s   L11D4
        neg.l   d1
L11D4   move.l  d0,d4
        beq.s   L1200
        bpl.s   L11DC
        neg.l   d0
L11DC   clr.l   d2
        moveq   #$1F,d3
L11E0   asl.l   #$01,d0
        roxl.l  #$01,d2
        cmp.l   d1,d2
        bcs.s   L11EC
        sub.l   d1,d2
        addq.l  #$01,d0
L11EC   dbf     d3,L11E0
        move.l  d2,d1
        eor.l   d4,d5
        bpl.s   L11F8
        neg.l   d0
L11F8   eor.l   d1,d4
        bpl.s   L1204
        neg.l   d1
        bra.s   L1204
L1200   clr.l   d1
L1202   clr.l   d0
L1204   movem.l (a7)+,d2-d5
        rts
; 
J120A   movem.l d1-d4,-(a7)
        move.l  d0,d4
        eor.l   d1,d4
        tst.l   d0
        beq.s   L1246
        bpl.s   L121A
        neg.l   d0
L121A   move.l  d0,d2
        tst.l   d1
        bne.s   L1224
        clr.l   d0
        bra.s   L1246
L1224   bpl.s   L1228
        neg.l   d1
L1228   move.l  d0,d3
        mulu.w  d1,d3
        swap    d2
        mulu.w  d1,d2
        swap    d2
        clr.w   d2
        add.l   d2,d3
        swap    d1
        mulu.w  d1,d0
        swap    d0
        clr.w   d0
        add.l   d3,d0
        tst.l   d4
        bpl.s   L1246
        neg.l   d0
L1246   movem.l (a7)+,d1-d4
        rts
; 
        ori.b   #$00,d0
        ori.b   #$00,d0
M1254   neg.l   d0
        movem.l (a7)+,d1-d4
        rts

;garbage data from here to end of rom

